/* Copyright (C) 1999-2000 Hans Petter K. Jansson
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * You can contact the library's author by sending e-mail to <hpj@styx.net>.
 */

#ifndef _FTIME_H
#define _FTIME_H 1

# ifdef LIBFLUX_BUILD

/* --- Timer function substitutions ---*/

# ifndef HAVE_TIMERCMP
#  define timercmp(a, b, CMP)                   \
  (((a)->tv_sec == (b)->tv_sec) ?                 \
   ((a)->tv_usec CMP (b)->tv_usec) :                \
      ((a)->tv_sec CMP (b)->tv_sec))
# endif

# ifndef HAVE_TIMERADD
#  define timeradd(a, b, result) \
do \
{ \
        (result)->tv_sec = (a)->tv_sec + (b)->tv_sec;           \
        (result)->tv_usec = (a)->tv_usec + (b)->tv_usec;            \
        if ((result)->tv_usec >= 1000000)               \
  { \
        ++(result)->tv_sec;                 \
        (result)->tv_usec -= 1000000;               \
  } \
} \
while (0)                                                                   
# endif

# ifndef HAVE_TIMERSUB  
#  define timersub(a, b, result) \
do \
{ \
                          \
        (result)->tv_sec = (a)->tv_sec - (b)->tv_sec;           \
        (result)->tv_usec = (a)->tv_usec - (b)->tv_usec;            \
        if ((result)->tv_usec < 0) \
    { \
              --(result)->tv_sec;                 \
              (result)->tv_usec += 1000000;               \
    } \
} \
while (0)                                                                   
# endif

# endif
#endif
