/* Copyright (C) 1999-2000 Hans Petter K. Jansson
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * You can contact the library's author by sending e-mail to <hpj@styx.net>.
 */

#include "config.h"
#include "bmem.h"
#include "bt.h"
#include "bt_priv.h"
#include <stdlib.h>


void bt_remove(BT *bt, void *key)
{
  BTN *c, *p, *x, *t;

  p = &bt->head;
  x = bt->head.right;
  bt->z.key = key;
  
  while (key != x->key)
  {
    p = x;
    x = (key < x->key) ? x->left : x->right;
  }

  if (x == &bt->z) return;  /* No such key; let's not free the sentinel node */

  t = x;
  if (t->right == &bt->z) x = x->left;
  else if (t->right->left == &bt->z)
  {
    x = x->right;
    x->left = t->left;
  }
  else
  {
    c = x->right;
    while (c->left->left != &bt->z) c = c->left;
    x = c->left;
    c->left = x->right;
    x->left = t->left;
    x->right = t->right;
  }

  if (key < p->key) p->left = x;
  else p->right = x;

  if (bt->bmem) bmem_block_del(bt->bmem, t);
  else free(t);
}
