/* Copyright (C) 1999-2000 Hans Petter K. Jansson
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * You can contact the library's author by sending e-mail to <hpj@styx.net>.
 */

#include "config.h"
#include "sock.h"
#include "nvtp.h"


NVTP *nvtp_accept(NVTP *nvtp)
{
  NVTP *nvtp_child;
  SOCK *s_child;
  
  s_child = sock_accept(nvtp_get_sock(nvtp));
  if (!s_child) return(0);

  nvtp_child = nvtp_new_with_sock(s_child);
  nvtp_child->parent = nvtp;
  
  return(nvtp_child);
}
