/* Copyright (C) 1999-2000 Hans Petter K. Jansson
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * You can contact the library's author by sending e-mail to <hpj@styx.net>.
 */

#include "config.h"
#include "nvtp.h"
#include "smtp.h"
#include <string.h>
#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>


void smtp_flush(SMTP *smtp)
{
  while (smtp_queue_out_len(smtp))
  {
    smtp_push(smtp);
    nvtp_flush(smtp_get_nvtp(smtp));
  }
  
  nvtp_flush(smtp_get_nvtp(smtp));
}


void smtp_grab(SMTP *smtp)
{
  fd_set fd_read, fd_write;

  while (!smtp_queue_in_len(smtp))
  {
    smtp_pull(smtp);
    smtp_push(smtp);
    FD_ZERO(&fd_read);
    FD_ZERO(&fd_write);
    FD_SET(smtp_get_fd_read(smtp), &fd_read);
    FD_SET(smtp_get_fd_write(smtp), &fd_write);

    while (!select(smtp_get_fd_read(smtp) > smtp_get_fd_write(smtp) ?
                   smtp_get_fd_read(smtp) + 1 : smtp_get_fd_write(smtp) + 1,
                   &fd_read, &fd_write, 0, 0)) ;
  }
}


/* --- */


TT *smtp_recv(SMTP *smtp)
{
  smtp_grab(smtp);
  if (!smtp_queue_in_len(smtp)) return(0);

  return(smtp_dequeue(smtp));
}
