/* Copyright (C) 1999-2000 Hans Petter K. Jansson
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * You can contact the library's author by sending e-mail to <hpj@styx.net>.
 */

#include "config.h"
#include "tt.h"
#include "nvtp.h"
#include "smtp.h"


void smtp_reply(SMTP *smtp, SMTP_REPLY_CODE code, char *string)
{
  char buf[16];
  TT *tt;
  
  sprintf(buf, "%03d", code);
  tt = tt_new_with_data(buf, strlen(buf));
  
  if (string)
  {
    tt_data_append_bytes(tt, " ", 1);
    tt_data_append_bytes(tt, string, strlen(string));
  }
  
  nvtp_enqueue_tt(smtp_get_nvtp(smtp), tt);
}


int smtp_parse_reply(SMTP *smtp, TT *tt)
{
  char buf[4];
  int code;
  
  if (tt_size(tt) < 3) return(0);

  tt_data_get_bytes(tt, buf, 0, 3);
  code = buf[0] * 100 + buf[1] * 10 + buf[2];

  return(code);
}
