/* Copyright (C) 2000 Andrei Zmievski <andrei@ispi.net>
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
 *
 * You can contact the library's author by sending e-mail to <flux@lists.styx.net>.
 */

#include "config.h"
#include "types.h"
#include "tt.h"
#include "tt_priv.h"

BMEM *tt_bmem = NULL;
void *(*tt_bmem_block_new)(void) = tt_bmem_init;
void (*tt_bmem_block_del)(void *) = tt_bmem_block_del_dummy;

void tt_init(void)
{
  if (!tt_bmem)
  {
    tt_bmem = bmem_new(sizeof(TT));
    tt_bmem_block_new = tt_bmem_block_new_func;
    tt_bmem_block_del = tt_bmem_block_del_func;
  }
}

void tt_shutdown(void)
{
  if (tt_bmem)
  {
    bmem_del(tt_bmem);
    tt_bmem = NULL;
    tt_bmem_block_new = tt_bmem_init;
    tt_bmem_block_del = tt_bmem_block_del_dummy;
  }
}
