# Configure macros for Flux
# Hans Petter Jansson, 20000120

dnl AM_PATH_GTK([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND [, MODULES]]]])
dnl Test for GTK, and define GTK_CFLAGS and GTK_LIBS
dnl
AC_DEFUN(AM_FLUX,
[

dnl
dnl Now check if the installed GTK is sufficiently new. (Also sanity
dnl checks the results of gtk-config to some extent
dnl
      rm -f conf.fluxtest
			AC_MSG_CHECKING(for flux)
			LIBS="-lflux $LIBS"
      AC_TRY_RUN([
#include <flux/flux.h>
#include <stdio.h>
#include <stdlib.h>

int 
main ()
{
  int major, minor, micro;
  char *tmp_version;

  system ("touch conf.fluxtest");

  /* HP/UX 9 (%@#!) writes to sscanf strings */
  tmp_version = strdup(flux_get_version());

  if (sscanf(tmp_version, "%d.%d.%d", &major, &minor, &micro) != 3)
	{
    printf("%s, bad version string\n", flux_get_version());
    exit(1);
  }
	
	exit(0);
}
],, no_flux=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])

  if test "x$no_flux" = x ; then
     AC_MSG_RESULT(found)
     ifelse([$2], , :, [$2])     
  else
     AC_MSG_RESULT(not found)
       if test -f conf.fluxtest ; then
        :
       else
          echo "*** Could not run Flux test program, checking why..."
          LIBS="-lflux $LIBS"
          AC_TRY_LINK([
#include <flux/flux.h>
#include <stdio.h>
],      [ return (0); ],
        [ echo "*** The test program compiled, but did not run. This usually means"
          echo "*** that the run-time linker is not finding Flux or finding the wrong"
          echo "*** version of Flux. If it is not finding Flux, you'll need to set your"
          echo "*** LD_LIBRARY_PATH environment variable, or edit /etc/ld.so.conf to point"
          echo "*** to the installed location  Also, make sure you have run ldconfig if that"
          echo "*** is required on your system."
	  echo "***"
          echo "*** If you have an old version installed, it is best to remove it, although"
          echo "*** you may also be able to get things to work by modifying LD_LIBRARY_PATH." ],
        [ echo "*** The test program failed to compile or link. See the file config.log for the"
          echo "*** exact error that occured. This usually means Flux was incorrectly installed"
          echo "*** or that you have moved Flux since it was installed." ])
          CFLAGS="$ac_save_CFLAGS"
          LIBS="$ac_save_LIBS"
       fi
       ifelse([$3], , :, [$3])
  fi
  rm -f conf.fluxtest
])
